Index: Makefile.am
===================================================================
--- Makefile.am	(revision 1489)
+++ Makefile.am	(revision 1490)
@@ -56,4 +56,7 @@
 	-rm -f $(MRPROPERFILES)
 
+deb:
+	dpkg-buildpackage -rfakeroot
+
 rpm: dist
 	rpmbuild -ta $(PACKAGE)-$(VERSION).tar.gz
@@ -68,3 +71,3 @@
 	bzip2 --best -c > $(PACKAGE)-$(VERSION).tar.bz2
 
-.PHONY: doc benchmark mrproper rpm dist-bz2 distcheck-bz2
+.PHONY: doc benchmark mrproper deb rpm dist-bz2 distcheck-bz2
Index: debian/README.Debian
===================================================================
--- debian/README.Debian	(revision 1490)
+++ debian/README.Debian	(revision 1490)
@@ -0,0 +1,6 @@
+lemon for Debian
+----------------
+
+<possible notes regarding this package - if none, delete this file>
+
+ -- LEMON Development Team <etik-ol@cs.elte.hu>, Tue, 14 Jun 2005 08:29:34 +0200
Index: debian/changelog
===================================================================
--- debian/changelog	(revision 1490)
+++ debian/changelog	(revision 1490)
@@ -0,0 +1,6 @@
+lemon (0.4-1) unstable; urgency=low
+
+  * Initial Release.
+
+ -- LEMON Development Team <etik-ol@cs.elte.hu>  Tue, 14 Jun 2005 08:29:34 +0200
+
Index: debian/compat
===================================================================
--- debian/compat	(revision 1490)
+++ debian/compat	(revision 1490)
@@ -0,0 +1,1 @@
+4
Index: debian/control
===================================================================
--- debian/control	(revision 1490)
+++ debian/control	(revision 1490)
@@ -0,0 +1,15 @@
+Source: lemon
+Section: unknown
+Priority: optional
+Maintainer: LEMON Development Team <etik-ol@cs.elte.hu>
+Build-Depends: debhelper (>= 4.0.0)
+Standards-Version: 3.6.1
+
+Package: lemon
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}, glpk
+Description: A C++ template library aimed at combinatorial optimization tasks.
+ LEMON stands for Library of Efficient Models and
+ Optimization in Networks. It is a C++ template
+ library aimed at combinatorial optimization tasks,
+ especially those working with graphs and networks.
Index: debian/copyright
===================================================================
--- debian/copyright	(revision 1490)
+++ debian/copyright	(revision 1490)
@@ -0,0 +1,43 @@
+This package was debianized by LEMON Development Team <etik-ol@cs.elte.hu> on
+Tue, 14 Jun 2005 08:29:34 +0200.
+
+It was downloaded from http://lemon.cs.elte.hu
+
+Copyright:
+
+Copyright (C) 2003-2005 Egervary Jeno Kombinatorikus Optimalizalasi
+Kutatocsoport (Egervary Combinatorial Optimization Research Group,
+EGRES).
+
+Upstream Author(s):
+
+Mihaly Barasz <klao@cs.elte.hu>
+Johanna Becker <beckerjc@cs.elte.hu>
+Attila Bernath <athos@cs.elte.hu>
+Alpar Juttner <alpar@cs.elte.hu>
+Marton Makai <marci@cs.elte.hu>
+Jacint Szabo <jacint@cs.elte.hu>
+
+License:
+
+Permission is hereby granted, free of charge, to any person or organization
+obtaining a copy of the software and accompanying documentation covered by
+this license (the "Software") to use, reproduce, display, distribute,
+execute, and transmit the Software, and to prepare derivative works of the
+Software, and to permit third-parties to whom the Software is furnished to
+do so, all subject to the following:
+
+The copyright notices in the Software and this entire statement, including
+the above license grant, this restriction and the following disclaimer,
+must be included in all copies of the Software, in whole or in part, and
+all derivative works of the Software, unless such copies or derivative
+works are solely in the form of machine-executable object code generated by
+a source language processor.
+
+THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
+SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
+FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
+ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+DEALINGS IN THE SOFTWARE.
Index: debian/dirs
===================================================================
--- debian/dirs	(revision 1490)
+++ debian/dirs	(revision 1490)
@@ -0,0 +1,2 @@
+usr/bin
+usr/sbin
Index: debian/docs
===================================================================
--- debian/docs	(revision 1490)
+++ debian/docs	(revision 1490)
@@ -0,0 +1,5 @@
+AUTHORS
+COPYING
+LICENSE
+NEWS
+README
Index: debian/lemon.doc-base
===================================================================
--- debian/lemon.doc-base	(revision 1490)
+++ debian/lemon.doc-base	(revision 1490)
@@ -0,0 +1,9 @@
+Document: lemon-refman
+Title: LEMON Reference Manual
+Author: LEMON Development Team
+Abstract: Documentation of LEMON.
+Section: unknown
+
+Format: HTML
+Index: /usr/share/doc/lemon/html/index.html
+Files: /usr/share/doc/lemon/html/*.html
Index: debian/rules
===================================================================
--- debian/rules	(revision 1490)
+++ debian/rules	(revision 1490)
@@ -0,0 +1,107 @@
+#!/usr/bin/make -f
+# -*- makefile -*-
+# Sample debian/rules that uses debhelper.
+# This file was originally written by Joey Hess and Craig Small.
+# As a special exception, when this file is copied by dh-make into a
+# dh-make output file, you may use that output file without restriction.
+# This special exception was added by Craig Small in version 0.37 of dh-make.
+
+# Uncomment this to turn on verbose mode.
+#export DH_VERBOSE=1
+
+
+# These are used for cross-compiling and for saving the configure script
+# from having to guess our platform (since we know it already)
+DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
+DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
+
+
+CFLAGS = -Wall -g
+
+ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
+	CFLAGS += -O0
+else
+	CFLAGS += -O2
+endif
+
+config.status: configure
+	dh_testdir
+	# Add here commands to configure the package.
+	CFLAGS="$(CFLAGS)" ./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info --with-docsuffix=lemon
+
+
+build: build-stamp
+
+build-stamp:  config.status
+	dh_testdir
+
+	# Add here commands to compile the package.
+	$(MAKE)
+	#docbook-to-man debian/lemon.sgml > lemon.1
+
+	touch build-stamp
+
+clean:
+	dh_testdir
+	dh_testroot
+	rm -f build-stamp 
+
+	# Add here commands to clean up after the build process.
+	-$(MAKE) distclean
+ifneq "$(wildcard /usr/share/misc/config.sub)" ""
+	cp -f /usr/share/misc/config.sub config.sub
+endif
+ifneq "$(wildcard /usr/share/misc/config.guess)" ""
+	cp -f /usr/share/misc/config.guess config.guess
+endif
+
+
+	dh_clean 
+
+install: build
+	dh_testdir
+	dh_testroot
+	dh_clean -k 
+	dh_installdirs
+
+	# Add here commands to install the package into debian/lemon.
+	$(MAKE) install DESTDIR=$(CURDIR)/debian/lemon
+
+
+# Build architecture-independent files here.
+binary-indep: build install
+# We have nothing to do by default.
+
+# Build architecture-dependent files here.
+binary-arch: build install
+	dh_testdir
+	dh_testroot
+	dh_installchangelogs ChangeLog
+	dh_installdocs
+	dh_installexamples
+#	dh_install
+#	dh_installmenu
+#	dh_installdebconf	
+#	dh_installlogrotate
+#	dh_installemacsen
+#	dh_installpam
+#	dh_installmime
+#	dh_installinit
+#	dh_installcron
+#	dh_installinfo
+#	dh_installman
+	dh_link
+	dh_strip
+	dh_compress
+	dh_fixperms
+#	dh_perl
+#	dh_python
+#	dh_makeshlibs
+	dh_installdeb
+	dh_shlibdeps
+	dh_gencontrol
+	dh_md5sums
+	dh_builddeb
+
+binary: binary-indep binary-arch
+.PHONY: build clean binary-indep binary-arch binary install 
Index: debian/watch
===================================================================
--- debian/watch	(revision 1490)
+++ debian/watch	(revision 1490)
@@ -0,0 +1,2 @@
+version=2
+http://lemon.cs.elte.hu/data/lemon-(.*)\.tar\.gz	debian	uupdate