Index: gui/broken_edge.cc
===================================================================
--- gui/broken_edge.cc	(revision 1505)
+++ gui/broken_edge.cc	(revision 1524)
@@ -8,6 +8,6 @@
   arrow=new Gnome::Canvas::Polygon(g);
   *arrow << Gnome::Canvas::Properties::fill_color("red");
-  arrow->signal_event().connect(sigc::mem_fun(*this, &BrokenEdge::edge_former_event_handler));
-  set_points(p);
+  arrow->signal_event().connect(sigc::mem_fun(*this, &BrokenEdge::edgeFormerEventHandler));
+  setPoints(p);
 }
 
@@ -17,5 +17,5 @@
 }
 
-void BrokenEdge::set_points(Gnome::Canvas::Points p, bool move)
+void BrokenEdge::setPoints(Gnome::Canvas::Points p, bool move)
 {
   bool set_arrow=false;
@@ -104,5 +104,5 @@
 }
 
-bool BrokenEdge::edge_former_event_handler(GdkEvent* e)
+bool BrokenEdge::edgeFormerEventHandler(GdkEvent* e)
 {
   switch(e->type)
@@ -110,7 +110,7 @@
     case GDK_BUTTON_PRESS:
       //we mark the location of the event to be able to calculate parameters of dragging
-      if(gdc.get_actual_tool()!=CREATE_NODE)
+      if(gdc.getActualTool()!=CREATE_NODE)
 	{
-	  gdc.toggle_edge_activity(this, true);
+	  gdc.toggleEdgeActivity(this, true);
 	  clicked_x=e->button.x;
 	  clicked_y=e->button.y;
@@ -119,7 +119,7 @@
       break;
     case GDK_BUTTON_RELEASE:
-      if(gdc.get_actual_tool()!=CREATE_NODE)
+      if(gdc.getActualTool()!=CREATE_NODE)
 	{
-	  gdc.toggle_edge_activity(this, false);
+	  gdc.toggleEdgeActivity(this, false);
 	  isbutton=false;
 	}
@@ -143,6 +143,6 @@
 	  points_new.push_back(my_points[2]);
 
-	  set_points(points_new);
-	  gdc.text_reposition(xy<double>(my_points[1].get_x(),my_points[1].get_y()));
+	  setPoints(points_new);
+	  gdc.textReposition(xy<double>(my_points[1].get_x(),my_points[1].get_y()));
 
 	  clicked_x=e->motion.x;
@@ -156,5 +156,5 @@
 }
 
-xy<double> BrokenEdge::get_arrow_pos()
+xy<double> BrokenEdge::getArrowPos()
 {
   xy<double> ret_val(my_points[1].get_x(),my_points[1].get_y());
Index: gui/broken_edge.h
===================================================================
--- gui/broken_edge.h	(revision 1505)
+++ gui/broken_edge.h	(revision 1524)
@@ -27,10 +27,10 @@
 
   ///event handler for forming edges
-  bool edge_former_event_handler(GdkEvent*);
+  bool edgeFormerEventHandler(GdkEvent*);
  public:
   BrokenEdge(Gnome::Canvas::Group &, Gnome::Canvas::Points, GraphDisplayerCanvas &);
   ~BrokenEdge();
-  void set_points(Gnome::Canvas::Points, bool move=false);
-  xy<double> get_arrow_pos();
+  void setPoints(Gnome::Canvas::Points, bool move=false);
+  xy<double> getArrowPos();
 };
 
Index: gui/edit_win.cc
===================================================================
--- gui/edit_win.cc	(revision 1494)
+++ gui/edit_win.cc	(revision 1524)
@@ -2,5 +2,5 @@
 #include <set>
 
-bool EditWin::close_if_escape_is_pressed(GdkEventKey* e)
+bool EditWin::closeIfEscapeIsPressed(GdkEventKey* e)
 {
   if(e->keyval==GDK_Escape)
@@ -16,5 +16,5 @@
   set_default_size(200, 50);
   set_keep_above(true);
-  signal_key_press_event().connect(sigc::mem_fun(*this, &EditWin::close_if_escape_is_pressed));
+  signal_key_press_event().connect(sigc::mem_fun(*this, &EditWin::closeIfEscapeIsPressed));
   
   //buttons array
Index: gui/edit_win.h
===================================================================
--- gui/edit_win.h	(revision 1478)
+++ gui/edit_win.h	(revision 1524)
@@ -30,5 +30,5 @@
   EditWin(const std::string& title, GraphDisplayerCanvas &);
 
-  virtual bool close_if_escape_is_pressed(GdkEventKey*);
+  virtual bool closeIfEscapeIsPressed(GdkEventKey*);
 
   ///Callback function in case of button pression.
Index: gui/graph_displayer_canvas-event.cc
===================================================================
--- gui/graph_displayer_canvas-event.cc	(revision 1512)
+++ gui/graph_displayer_canvas-event.cc	(revision 1524)
@@ -21,5 +21,5 @@
 	generated->type=GDK_BUTTON_RELEASE;
 	generated->button.button=3;
-	create_edge_event_handler(generated);      
+	createEdgeEventHandler(generated);      
     }
 
@@ -29,18 +29,18 @@
     {
     case MOVE:
-      actual_handler=displayed_graph.signal_event().connect(sigc::mem_fun(*this, &GraphDisplayerCanvas::move_event_handler), false);
+      actual_handler=displayed_graph.signal_event().connect(sigc::mem_fun(*this, &GraphDisplayerCanvas::moveEventHandler), false);
       break;
 
       //it has to assigned to canvas, because all the canvas has to be monitored, not only the elements of the already drawn group
     case CREATE_NODE:
-      actual_handler=signal_event().connect(sigc::mem_fun(*this, &GraphDisplayerCanvas::create_node_event_handler), false);
+      actual_handler=signal_event().connect(sigc::mem_fun(*this, &GraphDisplayerCanvas::createNodeEventHandler), false);
       break;
 
     case CREATE_EDGE:
-      actual_handler=displayed_graph.signal_event().connect(sigc::mem_fun(*this, &GraphDisplayerCanvas::create_edge_event_handler), false);
+      actual_handler=displayed_graph.signal_event().connect(sigc::mem_fun(*this, &GraphDisplayerCanvas::createEdgeEventHandler), false);
       break;
 
     case ERASER:
-      actual_handler=displayed_graph.signal_event().connect(sigc::mem_fun(*this, &GraphDisplayerCanvas::eraser_event_handler), false);
+      actual_handler=displayed_graph.signal_event().connect(sigc::mem_fun(*this, &GraphDisplayerCanvas::eraserEventHandler), false);
       break;
 
@@ -50,10 +50,10 @@
 }
 
-int GraphDisplayerCanvas::get_actual_tool()
+int GraphDisplayerCanvas::getActualTool()
 {
   return actual_tool;
 }
 
-bool GraphDisplayerCanvas::move_event_handler(GdkEvent* e)
+bool GraphDisplayerCanvas::moveEventHandler(GdkEvent* e)
 {
   switch(e->type)
@@ -125,13 +125,13 @@
 	    if(isbutton==3)
 	      {
-		edgesmap[ei]->set_points(coos);
+		edgesmap[ei]->setPoints(coos);
 	      }
 	    else
 	      {
-		edgesmap[ei]->set_points(coos,true);
+		edgesmap[ei]->setPoints(coos,true);
 	      }
 
 	    //reposition of edgetext
-	    xy<double> text_pos=edgesmap[ei]->get_arrow_pos();
+	    xy<double> text_pos=edgesmap[ei]->getArrowPos();
 	    text_pos+=(xy<double>(10,10));
 	    edgetextmap[ei]->property_x().set_value(text_pos.x);
@@ -153,12 +153,12 @@
 	    if(isbutton==3)
 	      {
-		edgesmap[ei]->set_points(coos);
+		edgesmap[ei]->setPoints(coos);
 	      }
 	    else
 	      {
-		edgesmap[ei]->set_points(coos,true);
+		edgesmap[ei]->setPoints(coos,true);
 	      }
 
-	    xy<double> text_pos=edgesmap[ei]->get_arrow_pos();
+	    xy<double> text_pos=edgesmap[ei]->getArrowPos();
 	    text_pos+=(xy<double>(10,10));
 	    edgetextmap[ei]->property_x().set_value(text_pos.x);
@@ -172,5 +172,5 @@
 }
 
-bool GraphDisplayerCanvas::create_node_event_handler(GdkEvent* e)
+bool GraphDisplayerCanvas::createNodeEventHandler(GdkEvent* e)
 {
   switch(e->type)
@@ -197,5 +197,5 @@
       nodetextmap[active_node]->property_fill_color().set_value("darkblue");
 
-      mapwin->update_node(active_node);
+      mapwin->updateNode(active_node);
 
       break;
@@ -210,5 +210,5 @@
 	generated->motion.y=world_motion_y;
 	generated->type=GDK_MOTION_NOTIFY;
-	move_event_handler(generated);      
+	moveEventHandler(generated);      
 	break;
       }
@@ -228,5 +228,5 @@
 }
 
-bool GraphDisplayerCanvas::create_edge_event_handler(GdkEvent* e)
+bool GraphDisplayerCanvas::createEdgeEventHandler(GdkEvent* e)
 {
   switch(e->type)
@@ -290,5 +290,5 @@
 
 		      //initiating values corresponding to new edge in maps
-		      mapstorage.init_maps_for_edge(active_edge);
+		      mapstorage.initMapsForEdge(active_edge);
 	  
 		      //calculating coordinates of new edge
@@ -312,5 +312,5 @@
 
 		      //initializing edge-text as well, to empty string
-		      xy<double> text_pos=edgesmap[active_edge]->get_arrow_pos();
+		      xy<double> text_pos=edgesmap[active_edge]->getArrowPos();
 		      text_pos+=(xy<double>(10,10));
 
@@ -319,5 +319,5 @@
 
 		      //updating its properties
-		      mapwin->update_edge(active_edge);
+		      mapwin->updateEdge(active_edge);
 		    }
 		  else
@@ -362,5 +362,5 @@
 }
 
-bool GraphDisplayerCanvas::eraser_event_handler(GdkEvent* e)
+bool GraphDisplayerCanvas::eraserEventHandler(GdkEvent* e)
 {
   switch(e->type)
@@ -415,12 +415,12 @@
 	      for(std::set<Graph::Edge>::iterator edge_set_it=edges_to_delete.begin();edge_set_it!=edges_to_delete.end();edge_set_it++)
 		{
-		  delete_item(*edge_set_it);
-		}
-	      delete_item(active_node);
+		  deleteItem(*edge_set_it);
+		}
+	      deleteItem(active_node);
 	    }
 	  //a simple edge was chosen
 	  else
 	    {
-	      delete_item(active_edge);
+	      deleteItem(active_edge);
 	    }
 
@@ -454,5 +454,5 @@
 }
 
-void GraphDisplayerCanvas::delete_item(NodeIt node_to_delete)
+void GraphDisplayerCanvas::deleteItem(NodeIt node_to_delete)
 {
   delete(nodetextmap[node_to_delete]);
@@ -461,5 +461,5 @@
 }
 
-void GraphDisplayerCanvas::delete_item(EdgeIt edge_to_delete)
+void GraphDisplayerCanvas::deleteItem(EdgeIt edge_to_delete)
 {
   delete(edgetextmap[edge_to_delete]);
@@ -468,5 +468,5 @@
 }
 
-void GraphDisplayerCanvas::delete_item(Graph::Edge edge_to_delete)
+void GraphDisplayerCanvas::deleteItem(Graph::Edge edge_to_delete)
 {
   delete(edgetextmap[edge_to_delete]);
@@ -475,5 +475,5 @@
 }
 
-void GraphDisplayerCanvas::text_reposition(xy<double> new_place)
+void GraphDisplayerCanvas::textReposition(xy<double> new_place)
 {
   new_place+=(xy<double>(10,10));
@@ -482,5 +482,5 @@
 }
 
-void GraphDisplayerCanvas::toggle_edge_activity(BrokenEdge* active_bre, bool on)
+void GraphDisplayerCanvas::toggleEdgeActivity(BrokenEdge* active_bre, bool on)
 {
   if(on)
Index: gui/graph_displayer_canvas.cc
===================================================================
--- gui/graph_displayer_canvas.cc	(revision 1512)
+++ gui/graph_displayer_canvas.cc	(revision 1524)
@@ -6,5 +6,5 @@
 {
   
-  actual_handler=signal_event().connect(sigc::mem_fun(*this, &GraphDisplayerCanvas::create_node_event_handler), false);
+  actual_handler=signal_event().connect(sigc::mem_fun(*this, &GraphDisplayerCanvas::createNodeEventHandler), false);
   actual_tool=CREATE_NODE;
 
@@ -31,5 +31,5 @@
     //initializing edge-text as well, to empty string
 
-    xy<double> text_pos=edgesmap[i]->get_arrow_pos();
+    xy<double> text_pos=edgesmap[i]->getArrowPos();
     text_pos+=(xy<double>(10,10));
 
Index: gui/graph_displayer_canvas.h
===================================================================
--- gui/graph_displayer_canvas.h	(revision 1512)
+++ gui/graph_displayer_canvas.h	(revision 1524)
@@ -71,5 +71,5 @@
   ///of the canvas
   ///DEPRECATED!!!!
-  bool event_handler(GdkEvent* e, Node n);
+  bool eventHandler(GdkEvent* e, Node n);
 
   ///actual event handler
@@ -79,36 +79,36 @@
 
   ///event handler for the case when move-tool is active
-  bool move_event_handler(GdkEvent*);
+  bool moveEventHandler(GdkEvent*);
   ///event handler for the case when create_node-tool is active
-  bool create_node_event_handler(GdkEvent*);
+  bool createNodeEventHandler(GdkEvent*);
   ///event handler for the case when create_edge-tool is active
-  bool create_edge_event_handler(GdkEvent*);
+  bool createEdgeEventHandler(GdkEvent*);
   ///event handler for the case when eraser-tool is active
-  bool eraser_event_handler(GdkEvent*);
+  bool eraserEventHandler(GdkEvent*);
   ///event handler for the case when eraser-tool is active
-  bool edge_map_edit_event_handler(GdkEvent*);
+  bool edgeMapEditEventHandler(GdkEvent*);
 
 public:
   ///Moves the text to new place
-  void text_reposition(xy<double>);
+  void textReposition(xy<double>);
   ///Activates an edge belonging to a BrokenEdge
-  void toggle_edge_activity(BrokenEdge*, bool);
+  void toggleEdgeActivity(BrokenEdge*, bool);
 
 public:
   ///\return the actual tool in hand
-  int get_actual_tool();
+  int getActualTool();
 
 private:
   ///Deletes the given element.
-  void delete_item(NodeIt);
+  void deleteItem(NodeIt);
   ///Deletes the given element.
-  void delete_item(EdgeIt);
+  void deleteItem(EdgeIt);
   ///Deletes the given element.
-  void delete_item(Graph::Edge);
+  void deleteItem(Graph::Edge);
 
 private:
 
   ///The graph, on which we work
-  Graph g;
+  Graph & g;
 
   ///Map of nodes of graph
Index: gui/map_win.cc
===================================================================
--- gui/map_win.cc	(revision 1512)
+++ gui/map_win.cc	(revision 1524)
@@ -2,5 +2,5 @@
 #include <set>
 
-bool MapWin::close_if_escape_is_pressed(GdkEventKey* e)
+bool MapWin::closeIfEscapeIsPressed(GdkEventKey* e)
 {
   if(e->keyval==GDK_Escape)
@@ -16,5 +16,5 @@
   set_default_size(200, 50);
 
-  signal_key_press_event().connect(sigc::mem_fun(*this, &MapWin::close_if_escape_is_pressed));
+  signal_key_press_event().connect(sigc::mem_fun(*this, &MapWin::closeIfEscapeIsPressed));
 
   e_combo_array=new Gtk::Combo [EDGE_PROPERTY_NUM];
@@ -75,5 +75,5 @@
      sigc::bind
      (
-      sigc::mem_fun(*this, &MapWin::e_combo_changed),
+      sigc::mem_fun(*this, &MapWin::eComboChanged),
       i
      )
@@ -154,5 +154,5 @@
      sigc::bind
      (
-      sigc::mem_fun(*this, &MapWin::n_combo_changed),
+      sigc::mem_fun(*this, &MapWin::nComboChanged),
       i
      )
@@ -180,5 +180,5 @@
 }
 
-void MapWin::e_combo_changed(int prop)
+void MapWin::eComboChanged(int prop)
 {
   Gtk::Entry* entry = e_combo_array[prop].get_entry();
@@ -215,5 +215,5 @@
 };
 
-void MapWin::n_combo_changed(int prop)
+void MapWin::nComboChanged(int prop)
 {
 
@@ -251,5 +251,5 @@
 };
 
-void MapWin::update_node(Graph::Node node)
+void MapWin::updateNode(Graph::Node node)
 {
   for(int i=0;i<NODE_PROPERTY_NUM;i++)
@@ -290,5 +290,5 @@
 }
 
-void MapWin::update_edge(Graph::Edge edge)
+void MapWin::updateEdge(Graph::Edge edge)
 {
   for(int i=0;i<EDGE_PROPERTY_NUM;i++)
Index: gui/map_win.h
===================================================================
--- gui/map_win.h	(revision 1512)
+++ gui/map_win.h	(revision 1524)
@@ -43,18 +43,18 @@
   ///appropriate function of the \ref GraphDisplayerCanvas
   ///to change the visible values of that attribute.
-  virtual void e_combo_changed(int);
+  virtual void eComboChanged(int);
   ///If a radiobutton is clicked, this function determines
   ///which button was that and after that calls the
   ///appropriate function of the \ref GraphDisplayerCanvas
   ///to change the visible values of that attribute.
-  virtual void n_combo_changed(int);
+  virtual void nComboChanged(int);
 
   ///This function is created to set the appropriate maps on the newly created node
-  void update_node(Graph::Node);
+  void updateNode(Graph::Node);
 
   ///This function is created to set the appropriate maps on the newly created edge
-  void update_edge(Graph::Edge);
+  void updateEdge(Graph::Edge);
 
-  virtual bool close_if_escape_is_pressed(GdkEventKey*);
+  virtual bool closeIfEscapeIsPressed(GdkEventKey*);
 };
 
Index: gui/mapstorage.cc
===================================================================
--- gui/mapstorage.cc	(revision 1512)
+++ gui/mapstorage.cc	(revision 1524)
@@ -101,5 +101,5 @@
 }
 
-void MapStorage::init_maps_for_edge(Graph::Edge e)
+void MapStorage::initMapsForEdge(Graph::Edge e)
 {
   e=e;
Index: gui/mapstorage.h
===================================================================
--- gui/mapstorage.h	(revision 1523)
+++ gui/mapstorage.h	(revision 1524)
@@ -83,8 +83,8 @@
 
   ///This function sets a default base value for the newly created node
-  void init_maps_for_node(NodeIt);
+  void initMapsForNode(NodeIt);
 
   ///This function sets a default base value for the newly created node
-  void init_maps_for_edge(Graph::Edge);
+  void initMapsForEdge(Graph::Edge);
 };
 